Bug 526533

Summary: Rebase of GDB to 7.0, the F12 version
Product: Red Hat Enterprise Linux 5 Reporter: Jan Kratochvil <jan.kratochvil>
Component: gdbAssignee: Jan Kratochvil <jan.kratochvil>
Status: CLOSED ERRATA QA Contact: BaseOS QE <qe-baseos-auto>
Severity: medium Docs Contact:
Priority: medium    
Version: 5.4CC: ebachalo, pmuller, rlerch, tao
Target Milestone: rcKeywords: Rebase
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Rebase: Bug Fixes and Enhancements
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2010-03-30 04:52:29 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 547870, 625372    
Bug Blocks: 520618    

Description Jan Kratochvil 2009-09-30 14:25:11 EDT
Description of problem:
Rebase to the F12 GDB (GDB-7.0) has been considered as the most feasible way to resolve Bug 467502 and Bug 520618 both showing larger problems with threads.

Version-Release number of selected component (if applicable):
gdb-6.8-37.el5 (RHEL-5.4)

Additional info:
Bug 467502 did show some problems in the threads support of FSF GDB 6.8 (which is the base for the current RHEL-5.4 GDB).
While re-evaluating this bugfix Bug 467502  for a new performance Bug 520618 found out various threads regressions.  Their fix would require too many patches to backport moreover having issues with the RH PIE (Position-Independent-Executable) patch.
F12 contains already the full fix set tested both in Fedora and by FSF GDB 7.0, the PIE patch compatibility is at least tested by Fedora (+SuSE).

A pre-6.8 regression in Bug 467502 was introduced by:
[8/9] multiple locations
http://sourceware.org/ml/gdb-patches/2007-09/msg00098.html
db046cf1d5df0f221ccaa92039946b1d185ae2b3

One of the later fixes was:
Re: [RFA] Try2: Ignore breakpoints when reading memory.
http://sourceware.org/ml/gdb-patches/2008-03/msg00106.html
f54853edc39f32e925ef88fa80fc7dae9ec1755a

A different also required fix was:
Fixes for a couple of infrun bugs (thread hop, revert to step thread).
http://sourceware.org/ml/gdb-patches/2009-05/msg00594.html
61f191dc6d87b039c58dd4cf7d64b07cb06c5b31

These patches introduce general restoration from breakpoint shadows which is not required for RHEL-5 but other patches heavily depend on it, incl. my performance fixing patch:
http://sourceware.org/ml/gdb-patches/2009-09/msg00105.html

This would mean either
(a) Introduce new untested fixes of the 6.8 threading bugs not based on the
    breakpoints shadow restoration patches.
or
(b) Properly cherry-pick all the breakpoints shadow restoration patches fixing
    the threading bugs, incl. rebasement of the RH PIE patch.
Neither of two paths provide small enough change not being tested in the field to be acceptable for RHEL-5.



F12 is now gdb-6.8.91.20090925-2.fc12 which is already from FSF GDB 7.0 branch (gdb_7_0-branch).  Formal gdb-7.0 Fedora update should be made soon after the FSF GDB release.

The rebase from Fedora will need some minor .spec adjustments for RHEL as before.
F12 Fedora will need minor fixups for RHEL-5 arches not on Fedora (ia64, s390x).
The rebase will include a full RHEL-5 arches regression test as usual.
Comment 4 Jan Kratochvil 2009-12-21 17:58:08 EST
Fixed in gdb-7.0-13.el5.
Comment 7 errata-xmlrpc 2010-03-30 04:52:29 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2010-0285.html